#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <vector>
#include <cmath>
#include "histogram.h"
using namespace std;

//!    (3 )!

//  Input   
	struct Input {
        vector<double> Numbers;
        size_t bin_count{};
    };

// 
Input input_data(){
    size_t number_count;
    Input stct;
    //   
    cerr << "Enter number count ";
	cin >> number_count;
    // 
	vector<double> Numbers(number_count);
	stct.Numbers.resize(number_count);
	cerr << "Enter array:\n";
	cin >> Numbers[0];
	for (int i = 1; i < number_count; i++) {
		cin >> stct.Numbers[i];
	}
	//  
	cerr << "Enter bin count\n";
	cin >> stct.bin_count;
	// 
	return stct;
}

//    
void show_histogram_text(const vector<size_t>& bins){
    const size_t SCREEN_WIDTH = 80;
    const size_t MAX_ASTERISK = SCREEN_WIDTH - 3 - 3;

    //  
	size_t max4scale = 0;
	for (size_t x : bins){
        if (x > max4scale){
            max4scale = x;
        }
	}
	if (max4scale > MAX_ASTERISK){
        for (size_t x : bins) {
            if (x >= 100){
                cout  << x << " | ";
            }
            else if (x >= 10){
                cout << " " << x << " | ";
            }
            else{
                cout << "  " << x << " | ";
            }
            size_t count = x;
            size_t height = MAX_ASTERISK * (static_cast<double>(count) / max4scale);
            for (size_t i = 0; i < height; i++) {
                cout << "*";
            }
            cout << "\n";
        }
	}
	else{
	//
	for (size_t x : bins) {
	    if (x >= 100){
            cout  << x << " | ";
	    }
	    else if (x >= 10){
            cout << " " << x << " | ";
	    }
	    else{
            cout << "  " << x << " | ";
	    }
		for (size_t i = 0; i < x; i++) {
			cout << "*";
		}
		cout << "\n";
    }
	}
	return;
}

int main() {
	//    
	Input in = input_data();

	//  bins  
	vector<size_t> bins = make_histogram(in.Numbers, in.bin_count);

	// 
	show_histogram_text(bins);

	return 0;
}
